#pragma once

#include <cstddef>
#include <functional>
#include <string>
#include <vector>

namespace rei::json {
	class JsonObject;
	class FieldValue;
	class JsonArray {

		public:

		JsonArray();

		JsonArray& push(FieldValue& value);
		JsonArray& push(FieldValue&& value);
		JsonArray& push(int value);
		JsonArray& push(bool value);
		JsonArray& push(const std::string& value);
		JsonArray& push(const std::string&& value);
		JsonArray& push(const char * value);
		JsonArray& push(const JsonObject& object);
		JsonArray& push(const JsonObject&& object);
		JsonArray& push(const JsonArray& array);
		JsonArray& push(const JsonArray&& array);
		JsonArray& pushNull();

		FieldValue& operator[](unsigned index);

		int getNumber(int index);
		bool getBool(int index);
		std::string getString(int index);
		JsonObject& getObject(int index);
		JsonArray& getArray(int index);
		bool hasNull(int index);

		void remove(int index);
		void forEach(std::function<void(FieldValue&, int)>);
		size_t count() const;

		private:
		std::vector<FieldValue> elements;
	};

}
